/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include <stdbool.h>
#include "main.h"
#include "crc.h"
#include "dma.h"
#include "tim.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#include "spi.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
void initPWM(TIM_HandleTypeDef timer, uint32_t channel, uint16_t period,
             uint16_t pulse) {
    //HAL_TIM_PWM_Stop(&timer, channel);
// stop generation of pwm
    TIM_OC_InitTypeDef sConfigOC;
    timer.Init.Period = period;
// set the period duration
    HAL_TIM_PWM_Init(&timer); // reinititialise with new period value
    sConfigOC.OCMode = TIM_OCMODE_PWM1;
    sConfigOC.Pulse = pulse;
// set the pulse duration
    sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
    sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
    HAL_TIM_PWM_ConfigChannel(&timer, &sConfigOC, channel);
    HAL_TIM_PWM_Start(&timer, channel);
}

void setPWM(TIM_HandleTypeDef timer, uint32_t channel, uint16_t period,
            uint16_t pulse) {
    //HAL_TIM_PWM_Stop(&timer, channel);
// stop generation of pwm
    TIM_OC_InitTypeDef sConfigOC;
    sConfigOC.OCMode = TIM_OCMODE_PWM1;
    sConfigOC.Pulse = pulse;
// set the pulse duration
    sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
    sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
    HAL_TIM_PWM_ConfigChannel(&timer, &sConfigOC, channel);
    //HAL_TIM_PWM_Start(&timer, channel);
}

void setDAC(uint8_t channel, uint16_t val) {
    uint16_t frame = val & 0x0FFF | 0x7000 & (channel << 12);
    HAL_SPI_Transmit(&hspi1, (uint8_t *) &frame, 1, 100);
}

bool dirty = false;
uint16_t mem[12] = {0};

#define BUFFER_SIZE 64
uint16_t RX_Buffer[BUFFER_SIZE] = {0};
uint16_t TX_Buffer[BUFFER_SIZE] = {0};

void HAL_SPI_CpltCallback(SPI_HandleTypeDef *hspi) {

    if(RX_Buffer[0]) {
        //HAL_SPI_Transmit_DMA(&hspi2, (uint8_t *) TX_Buffer, 4);
        union {
            struct {
                unsigned dat: 16;
                unsigned addr: 12;
                unsigned op: 4;
            } __attribute__((packed));
            struct {
                uint16_t high;
                uint16_t low;
            } __attribute__((packed));

        } frame = {.low=RX_Buffer[0], .high = RX_Buffer[1]};
        frame.op = 0xe;
        TX_Buffer[1] = frame.high;
        TX_Buffer[0] = frame.low;
        HAL_SPI_TransmitReceive_DMA(&hspi2, (uint8_t *) TX_Buffer, (uint8_t *) RX_Buffer, 4);
    } else {
        //HAL_GPIO_WritePin(GPIOB, GPIO_PIN_14, GPIO_PIN_SET);
        HAL_SPI_Receive_DMA(&hspi2, (uint8_t *) RX_Buffer, 4);
        //HAL_GPIO_WritePin(GPIOB, GPIO_PIN_14, GPIO_PIN_RESET);
    }
}

void HAL_SPI_RxCpltCallback(SPI_HandleTypeDef *hspi) {
    HAL_SPI_CpltCallback(hspi);
}

void HAL_SPI_TxRxCpltCallback(SPI_HandleTypeDef *hspi) {
    HAL_SPI_CpltCallback(hspi);
}

void HAL_SPI_TxCpltCallback(SPI_HandleTypeDef *hspi) {
    //HAL_SPI_Transmit_DMA(&hspi2, (uint8_t *) TX_Buffer, 4);
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void) {
    /* USER CODE BEGIN 1 */

    /* USER CODE END 1 */

    /* MCU Configuration--------------------------------------------------------*/

    /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
    HAL_Init();

    /* USER CODE BEGIN Init */

    /* USER CODE END Init */

    /* Configure the system clock */
    SystemClock_Config();

    /* USER CODE BEGIN SysInit */

    /* USER CODE END SysInit */

    /* Initialize all configured peripherals */
    MX_GPIO_Init();
    MX_CRC_Init();
    MX_TIM1_Init();
    MX_DMA_Init();
    MX_TIM3_Init();
    /* USER CODE BEGIN 2 */
    MX_SPI1_Init();
    MX_SPI2_Init();

    /*GPIO_InitTypeDef GPIO_InitStruct = {0};
    GPIO_InitStruct.Pin = GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10 | GPIO_PIN_11;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

    GPIO_InitStruct.Pin = GPIO_PIN_4 | GPIO_PIN_5;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

    HAL_GPIO_WritePin(GPIOA, GPIO_PIN_8, GPIO_PIN_SET);
    HAL_GPIO_WritePin(GPIOA, GPIO_PIN_9, GPIO_PIN_SET);
    HAL_GPIO_WritePin(GPIOA, GPIO_PIN_10, GPIO_PIN_SET);
    HAL_GPIO_WritePin(GPIOA, GPIO_PIN_11, GPIO_PIN_SET);

    HAL_GPIO_WritePin(GPIOB, GPIO_PIN_4, GPIO_PIN_SET);
    HAL_GPIO_WritePin(GPIOB, GPIO_PIN_5, GPIO_PIN_SET);*/



    setDAC(0, 50 << 4);
    setDAC(1, 50 << 4);
    setDAC(2, 50 << 4);
    setDAC(3, 50 << 4);
    setDAC(4, 50 << 4);
    setDAC(5, 50 << 4);

    initPWM(htim1, TIM_CHANNEL_1, 255, 10);
    initPWM(htim1, TIM_CHANNEL_2, 255, 10);
    initPWM(htim1, TIM_CHANNEL_3, 255, 10);
    initPWM(htim1, TIM_CHANNEL_4, 255, 10);
    initPWM(htim3, TIM_CHANNEL_1, 255, 10);
    initPWM(htim3, TIM_CHANNEL_2, 255, 10);

    uint16_t frame = 0b1001000000000000;
    HAL_SPI_Transmit(&hspi1, (uint8_t *) &frame, 1, 100);

    HAL_SPI_Receive_DMA(&hspi2, (uint8_t *) RX_Buffer, 4);

    /*Configure GPIO pin : PtPin */
    /*GPIO_InitTypeDef GPIO_InitStruct = {0};
    GPIO_InitStruct.Pin = GPIO_PIN_14;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);*/

    /*GPIO_InitTypeDef GPIO_InitStruct = {0};
    GPIO_InitStruct.Pin = GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10 | GPIO_PIN_11;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);*/

    /* USER CODE END 2 */

    /* Infinite loop */
    /* USER CODE BEGIN WHILE */
    while (1) {
        /* USER CODE END WHILE */

        /* USER CODE BEGIN 3 */

        /*
        setPWM(htim1, TIM_CHANNEL_1, 255, 255);
        setPWM(htim1, TIM_CHANNEL_2, 255, 255);
        setPWM(htim1, TIM_CHANNEL_3, 255, 255);
        setPWM(htim1, TIM_CHANNEL_4, 255, 255);
        setPWM(htim3, TIM_CHANNEL_1, 255, 255);
        setPWM(htim3, TIM_CHANNEL_1, 255, 255);*/

        /*for (int j = 0; j < 20; j++)
            for (int i = 0; i < 20; i++) {
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_8, GPIO_PIN_SET);
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_9, GPIO_PIN_SET);
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_10, GPIO_PIN_SET);
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_11, GPIO_PIN_SET);
            HAL_GPIO_WritePin(SIGNAL_LED_GPIO_Port, SIGNAL_LED_Pin, GPIO_PIN_SET);
            HAL_Delay(j);
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_8, GPIO_PIN_RESET);
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_9, GPIO_PIN_RESET);
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_10, GPIO_PIN_RESET);
            HAL_GPIO_WritePin(GPIOA, GPIO_PIN_11, GPIO_PIN_RESET);
            HAL_GPIO_WritePin(SIGNAL_LED_GPIO_Port, SIGNAL_LED_Pin, GPIO_PIN_RESET);
            HAL_Delay(19-j);
        }*/

        /*for (int i = 50; i < 256; i++) {
            setPWM(htim1, TIM_CHANNEL_1, 255, i);
            setPWM(htim1, TIM_CHANNEL_2, 255, i);
            setPWM(htim1, TIM_CHANNEL_3, 255, i);
            setPWM(htim1, TIM_CHANNEL_4, 255, i);
            HAL_Delay(5);
        }*/

        for (int i = 50; i < 256; i++) {
            setDAC(0, i << 4);
            setDAC(1, i << 4);
            setDAC(2, i << 4);
            setDAC(3, i << 4);
            setDAC(4, i << 4);
            setDAC(5, i << 4);
            HAL_Delay(5);
        }
        for (int i = 0; i < 206; i++) {
            setDAC(0, (255 - i) << 4);
            setDAC(1, (255 - i) << 4);
            setDAC(2, (255 - i) << 4);
            setDAC(3, (255 - i) << 4);
            setDAC(4, (255 - i) << 4);
            setDAC(5, (255 - i) << 4);
            HAL_Delay(5);
        }


        //HAL_SPI

        /*uint16_t val = 682;
        setDAC(0, val);
        setDAC(1, val);
        setDAC(2, val);
        setDAC(3, val);
        setDAC(4, val);
        setDAC(5, val);
         */

        // HAL_Delay(500);

        //HAL_GPIO_WritePin(SIGNAL_LED_GPIO_Port, SIGNAL_LED_Pin, GPIO_PIN_SET);

        //HAL_Delay(500);

        initPWM(htim1, TIM_CHANNEL_1, 255, 255);
        initPWM(htim1, TIM_CHANNEL_2, 255, 255);
        initPWM(htim1, TIM_CHANNEL_3, 255, 255);
        initPWM(htim1, TIM_CHANNEL_4, 255, 255);
        initPWM(htim3, TIM_CHANNEL_1, 255, 255);
        initPWM(htim3, TIM_CHANNEL_2, 255, 255);

        for (int i = 50; i < 256; i++) {
            setDAC(0, i << 4);
            setDAC(1, i << 4);
            setDAC(2, i << 4);
            setDAC(3, i << 4);
            setDAC(4, i << 4);
            setDAC(5, i << 4);
            HAL_Delay(5);
        }
        for (int i = 0; i < 206; i++) {
            setDAC(0, (255 - i) << 4);
            setDAC(1, (255 - i) << 4);
            setDAC(2, (255 - i) << 4);
            setDAC(3, (255 - i) << 4);
            setDAC(4, (255 - i) << 4);
            setDAC(5, (255 - i) << 4);
            HAL_Delay(5);
        }

        initPWM(htim1, TIM_CHANNEL_1, 255, 10);
        initPWM(htim1, TIM_CHANNEL_2, 255, 10);
        initPWM(htim1, TIM_CHANNEL_3, 255, 10);
        initPWM(htim1, TIM_CHANNEL_4, 255, 10);
        initPWM(htim3, TIM_CHANNEL_1, 255, 10);
        initPWM(htim3, TIM_CHANNEL_2, 255, 10);

        /*HAL_Delay(5000);
        val = 0xFFF;
        setDAC(0, val);
        setDAC(1, val);
        setDAC(2, val);
        setDAC(3, val);
        setDAC(4, val);
        setDAC(5, val);*/
    }
    /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void) {
    RCC_OscInitTypeDef RCC_OscInitStruct = {0};
    RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

    /** Initializes the RCC Oscillators according to the specified parameters
    * in the RCC_OscInitTypeDef structure.
    */
    RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
    RCC_OscInitStruct.HSIState = RCC_HSI_ON;
    RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
    RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
    RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
    RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL4;
    RCC_OscInitStruct.PLL.PREDIV = RCC_PREDIV_DIV1;
    if(HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK) {
        Error_Handler();
    }
    /** Initializes the CPU, AHB and APB buses clocks
    */
    RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_SYSCLK
                                  | RCC_CLOCKTYPE_PCLK1;
    RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
    RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV16;
    RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;

    if(HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_0) != HAL_OK) {
        Error_Handler();
    }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void) {
    /* USER CODE BEGIN Error_Handler_Debug */
    /* User can add his own implementation to report the HAL error return state */
    __disable_irq();
    while (1) {
    }
    /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

